From 133a9b978b1afa0286fcf5464a0fd5fc4b8b31a1 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 21 2020 21:30:47 +0000
Subject: [PATCH 1757/2232] Recognize extern function return value as trivial reason


---

diff --git a/syntax/trivial.rs b/syntax/trivial.rs
index 85184d8..d74bd66 100644
--- a/syntax/trivial.rs
+++ b/syntax/trivial.rs
@@ -11,7 +11,7 @@ pub enum TrivialReason<'a> {
     FunctionReturn(&'a ExternFn),
     BoxTarget,
     VecElement,
-    UnpinnedMutArg(&'a ExternFn),
+    UnpinnedMut(&'a ExternFn),
 }
 
 pub fn required_trivial_reasons<'a>(
@@ -48,7 +48,7 @@ pub fn required_trivial_reasons<'a>(
             Api::CxxFunction(efn) | Api::RustFunction(efn) => {
                 if let Some(receiver) = &efn.receiver {
                     if receiver.mutable && !receiver.pinned {
-                        let reason = TrivialReason::UnpinnedMutArg(efn);
+                        let reason = TrivialReason::UnpinnedMut(efn);
                         insist_extern_types_are_trivial(&receiver.ty, reason);
                     }
                 }
@@ -61,7 +61,7 @@ pub fn required_trivial_reasons<'a>(
                         Type::Ref(ty) => {
                             if ty.mutable && !ty.pinned {
                                 if let Type::Ident(ident) = &ty.inner {
-                                    let reason = TrivialReason::UnpinnedMutArg(efn);
+                                    let reason = TrivialReason::UnpinnedMut(efn);
                                     insist_extern_types_are_trivial(ident, reason);
                                 }
                             }
@@ -70,9 +70,20 @@ pub fn required_trivial_reasons<'a>(
                     }
                 }
                 if let Some(ret) = &efn.ret {
-                    if let Type::Ident(ident) = &ret {
-                        let reason = TrivialReason::FunctionReturn(efn);
-                        insist_extern_types_are_trivial(ident, reason);
+                    match ret {
+                        Type::Ident(ident) => {
+                            let reason = TrivialReason::FunctionReturn(efn);
+                            insist_extern_types_are_trivial(ident, reason);
+                        }
+                        Type::Ref(ty) => {
+                            if ty.mutable && !ty.pinned {
+                                if let Type::Ident(ident) = &ty.inner {
+                                    let reason = TrivialReason::UnpinnedMut(efn);
+                                    insist_extern_types_are_trivial(ident, reason);
+                                }
+                            }
+                        }
+                        _ => {}
                     }
                 }
             }
@@ -132,7 +143,7 @@ pub fn as_what<'a>(name: &'a Pair, reasons: &'a [TrivialReason]) -> impl Display
                     }
                     TrivialReason::BoxTarget => box_target = true,
                     TrivialReason::VecElement => vec_element = true,
-                    TrivialReason::UnpinnedMutArg(efn) => {
+                    TrivialReason::UnpinnedMut(efn) => {
                         unpinned_mut.insert(&efn.name.rust);
                     }
                 }
@@ -177,7 +188,7 @@ pub fn as_what<'a>(name: &'a Pair, reasons: &'a [TrivialReason]) -> impl Display
             if !unpinned_mut.is_empty() {
                 clauses.push(Clause::Set {
                     article: "a",
-                    desc: "non-pinned mutable reference argument of",
+                    desc: "non-pinned mutable reference in signature of",
                     set: &unpinned_mut,
                 });
             }
diff --git a/tests/ui/pin_mut_opaque.stderr b/tests/ui/pin_mut_opaque.stderr
index 53e651e..95af3cd 100644
--- a/tests/ui/pin_mut_opaque.stderr
+++ b/tests/ui/pin_mut_opaque.stderr
@@ -16,7 +16,7 @@ error: mutable reference to C++ type requires a pin -- use Pin<&mut CxxVector<..
 9 |         fn v(v: &mut CxxVector<u8>);
   |                 ^^^^^^^^^^^^^^^^^^
 
-error: needs a cxx::ExternType impl in order to be used as a non-pinned mutable reference argument of `f`, `g`, `h`
+error: needs a cxx::ExternType impl in order to be used as a non-pinned mutable reference in signature of `f`, `g`, `h`
  --> $DIR/pin_mut_opaque.rs:4:9
   |
 4 |         type Opaque;

